// Copyright (c) 2019-present, Facebook, Inc.
// All rights reserved.
//
// This source code is licensed under the BSD-style license found in the
// LICENSE file in the root directory of this source tree. An additional grant
// of patent rights can be found in the PATENTS file in the same directory.

#pragma once
#include <devmand/devices/cli/schema/Path.h>

namespace devmand::test::utils::cli {
using devmand::devices::cli::Path;

string statePathWithKey =
    "/openconfig-interfaces:interfaces/openconfig-interfaces:interface[name='0/2']/openconfig-interfaces:state";
string statePath =
    "/openconfig-interfaces:interfaces/openconfig-interfaces:interface/openconfig-interfaces:state";
string counterPath = statePath + "/counters";

string simpleReplaceInterface =
    "{\n"
    "                \"openconfig-interfaces:interfaces\": {\n"
    "                    \"interface\": [\n"
    "                        {\n"
    "                            \"state\": {\n"
    "                                \"name\": \"0/2\",\n"
    "                                \"counters\": {\n"
    "                                    \"out-octets\": 999 \n"
    "                                }\n"
    "                            },\n"
    "                            \"config\": {\n"
    "                                \"name\": \"0/2\"\n"
    "                            },\n"
    "                            \"subinterfaces\": { \n"
    "                                \"subinterface\": [\n"
    "                                    {\n"
    "                                    \"config\": {\n"
    "                                        \"index\": 0\n"
    "                                    },\n"
    "                                    \"index\": 0\n"
    "                                    }\n"
    "                                ]\n"
    "                            },\n"
    "                            \"name\": \"0/2\"\n"
    "                        }\n"
    "                    ]\n"
    "                }\n"
    "            }";

string simpleInterfaces =
    "{\n"
    "  \"openconfig-interfaces:interfaces\": {\n"
    "    \"interface\": [\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"0/1\",\n"
    "          \"counters\": {\n"
    "            \"out-octets\": 662648417\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/1\"\n"
    "        },\n"
    "        \"name\": \"0/1\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"0/2\",\n"
    "          \"counters\": {\n"
    "            \"out-octets\": 662648417\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/2\"\n"
    "        },\n"
    "        \"name\": \"0/2\"\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}";

string ifaces02 =
    "{\n"
    "  \"openconfig-interfaces:interfaces\": {\n"
    "    \"interface\": [\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"enabled\": true,\n"
    "          \"description\": \"dummy state\",\n"
    "          \"mtu\": 1518,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/2\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"enabled\": true,\n"
    "          \"description\": \"this is a config description\",\n"
    "          \"mtu\": 1500,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/2\"\n"
    "        },\n"
    "        \"name\": \"0/2\"\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}";

string openconfigInterfacesInterfaces =
    "{\n"
    "  \"openconfig-interfaces:interfaces\": {\n"
    "    \"interface\": [\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"description\": \"This is ifc  0/2\",\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1500,\n"
    "          \"name\": \"0/2\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/2\",\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"counters\": {\n"
    "            \"in-broadcast-pkts\": 2767640,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-multicast-pkts\": 5769311,\n"
    "            \"in-octets\": 427066814515,\n"
    "            \"in-unicast-pkts\": 293117,\n"
    "            \"out-broadcast-pkts\": 7628,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-multicast-pkts\": 325039,\n"
    "            \"out-octets\": 72669652,\n"
    "            \"out-unicast-pkts\": 125182\n"
    "          },\n"
    "          \"description\": \"Some descr\",\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1518,\n"
    "          \"name\": \"0/2\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"description\": \"This is ifc  0/3\",\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1500,\n"
    "          \"name\": \"0/3\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/3\",\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"counters\": {\n"
    "            \"in-broadcast-pkts\": 2767641,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-multicast-pkts\": 5769311,\n"
    "            \"in-octets\": 427066814515,\n"
    "            \"in-unicast-pkts\": 293117,\n"
    "            \"out-broadcast-pkts\": 7628,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-multicast-pkts\": 325039,\n"
    "            \"out-octets\": 72669652,\n"
    "            \"out-unicast-pkts\": 125182\n"
    "          },\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1518,\n"
    "          \"name\": \"0/3\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"description\": \"This is ifc  0/4\",\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1500,\n"
    "          \"name\": \"0/4\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/4\",\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"counters\": {\n"
    "            \"in-broadcast-pkts\": 2767642,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-multicast-pkts\": 5769311,\n"
    "            \"in-octets\": 427066814515,\n"
    "            \"in-unicast-pkts\": 293117,\n"
    "            \"out-broadcast-pkts\": 7628,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-multicast-pkts\": 325039,\n"
    "            \"out-octets\": 72669652,\n"
    "            \"out-unicast-pkts\": 125182\n"
    "          },\n"
    "          \"enabled\": true,\n"
    "          \"mtu\": 1518,\n"
    "          \"name\": \"0/4\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}";

Path newInterfaceTopPath(
    "/openconfig-interfaces:interfaces/interface[name='0/85']");

Path interface02TopPath(
    "/openconfig-interfaces:interfaces/interface[name='0/2']");

string operStatus =
    "/openconfig-interfaces:interfaces/openconfig-interfaces:interface/openconfig-interfaces:state/openconfig-interfaces:oper-status";

string newInterface =
    "{\n"
    "  \"openconfig-interfaces:interface\": [\n"
    "      {\n"
    "        \"name\": \"0/85\",\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"name\": \"0/85\",\n"
    "          \"mtu\": 1518,\n"
    "          \"enabled\": true,\n"
    "          \"description\": \"Some descr\",\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": \"125182\",\n"
    "            \"out-octets\": \"72669652\",\n"
    "            \"out-multicast-pkts\": \"325039\",\n"
    "            \"out-errors\": \"0\",\n"
    "            \"out-discards\": \"0\",\n"
    "            \"out-broadcast-pkts\": \"7628\",\n"
    "            \"in-unicast-pkts\": \"293117\",\n"
    "            \"in-octets\": \"427066814515\",\n"
    "            \"in-multicast-pkts\": \"5769311\",\n"
    "            \"in-errors\": \"0\",\n"
    "            \"in-discards\": \"0\",\n"
    "            \"in-broadcast-pkts\": \"2767640\"\n"
    "          },\n"
    "          \"admin-status\": \"UP\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/85\",\n"
    "          \"mtu\": 1500,\n"
    "          \"enabled\": true,\n"
    "          \"description\": \"This is ifc  0/85\"\n"
    "        },\n"
    "        \"hold-time\": {\n"
    "          \"state\": {\n"
    "            \"up\": 0,\n"
    "            \"down\": 0\n"
    "          }\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "}";

string interfaceCounters =
    "/openconfig-interfaces:interfaces/openconfig-interfaces:interface/openconfig-interfaces:state/openconfig-interfaces:counters";

string interfaceCountersWithKey =
    "/openconfig-interfaces:interfaces/openconfig-interfaces:interface[name='0/2']/openconfig-interfaces:state/openconfig-interfaces:counters";

string interface02state =
    "{\n"
    "  \"openconfig-interfaces:state\": {\n"
    "    \"admin-status\": \"UP\",\n"
    "    \"counters\": {\n"
    "      \"in-broadcast-pkts\": \"2767640\",\n"
    "      \"in-discards\": \"0\",\n"
    "      \"in-errors\": \"0\",\n"
    "      \"in-multicast-pkts\": \"5769311\",\n"
    "      \"in-octets\": \"427066814515\",\n"
    "      \"in-unicast-pkts\": \"293117\",\n"
    "      \"out-broadcast-pkts\": \"7628\",\n"
    "      \"out-discards\": \"0\",\n"
    "      \"out-errors\": \"0\",\n"
    "      \"out-multicast-pkts\": \"325039\",\n"
    "      \"out-octets\": \"72669652\",\n"
    "      \"out-unicast-pkts\": \"125182\"\n"
    "    },\n"
    "    \"description\": \"Some descr\",\n"
    "    \"enabled\": true,\n"
    "    \"mtu\": 1518,\n"
    "    \"name\": \"0/2\",\n"
    "    \"oper-status\": \"DOWN\",\n"
    "    \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "  }\n"
    "}";

string updated011Interface =
    "{\n"
    "    \"openconfig-interfaces:interface\": [\n"
    "      {\n"
    "        \"name\": \"0/11\",\n"
    "        \"config\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/11\",\n"
    "          \"enabled\": false\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "}";

string networkInstances =
    "{\n"
    "  \"openconfig-network-instance:network-instances\": {\n"
    "    \"network-instance\": [\n"
    "      {\n"
    "        \"vlans\": {\n"
    "          \"vlan\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"vlan-id\": 1,\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"vlan-id\": \"1\"\n"
    "            },\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"vlan-id\": 77\n"
    "              },\n"
    "              \"vlan-id\": \"77\"\n"
    "            },\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"vlan-id\": 99,\n"
    "                \"name\": \"testing\",\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"vlan-id\": \"99\"\n"
    "            },\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"vlan-id\": 787,\n"
    "                \"name\": \"another\",\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"vlan-id\": \"787\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"type\": \"openconfig-network-instance-types:DEFAULT_INSTANCE\",\n"
    "          \"name\": \"default\"\n"
    "        },\n"
    "        \"name\": \"default\"\n"
    "      }\n"
    "    ]\n"
    "  },\n"
    "  \"openconfig-interfaces:interfaces\": {\n"
    "    \"interface\": [\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/1\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/1\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/2\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/2\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/3\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/3\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/4\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/4\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"description\": \"testing\",\n"
    "          \"name\": \"0/5\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/5\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/6\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/6\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"access-vlan\": 787,\n"
    "              \"interface-mode\": \"ACCESS\"\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/7\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/7\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                77,\n"
    "                787\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\"\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/8\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/8\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                787\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\"\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/9\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/9\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                33\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\"\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/10\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/10\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                1,\n"
    "                100\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\",\n"
    "              \"access-vlan\": 77\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/11\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/11\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/12\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/12\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/13\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/13\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/14\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/14\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/15\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/15\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/16\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/16\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/17\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/17\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"0/18\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/18\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/1\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/1\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/2\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/2\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/3\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/3\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/4\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/4\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/5\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/5\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"name\": \"3/6\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/6\"\n"
    "      },\n"
    "      {\n"
    "        \"config\": {\n"
    "          \"description\": \"routedVlan\",\n"
    "          \"name\": \"4/1\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:l3ipvlan\"\n"
    "        },\n"
    "        \"name\": \"4/1\"\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}";

string threeTrees =
    "{\n"
    "  \"openconfig-spanning-tree:stp\": {\n"
    "    \"global\": {\n"
    "      \"state\": {\n"
    "        \"enabled-protocol\": [\n"
    "          \"openconfig-spanning-tree-types:MSTP\"\n"
    "        ],\n"
    "        \"bpdu-guard\": false,\n"
    "        \"bpdu-filter\": true\n"
    "      }\n"
    "    }\n"
    "  },\n"
    "  \"openconfig-interfaces:interfaces\": {\n"
    "    \"interface\": [\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"0/1\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"counters\": {\n"
    "            \"out-multicast-pkts\": 4233372,\n"
    "            \"out-broadcast-pkts\": 3456,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-unicast-pkts\": 767985,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-octets\": 620452580,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 3000827,\n"
    "            \"in-broadcast-pkts\": 34893690,\n"
    "            \"in-octets\": 55578046336,\n"
    "            \"in-multicast-pkts\": 76232842,\n"
    "            \"in-discards\": 0\n"
    "          },\n"
    "          \"oper-status\": \"UP\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/1\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/1\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"name\": \"0/2\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/2\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/2\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/3\",\n"
    "          \"enabled\": true,\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"counters\": {\n"
    "            \"out-octets\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-discards\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/3\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/3\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"0/4\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-discards\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/4\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/4\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"name\": \"0/5\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": false,\n"
    "          \"description\": \"testing\",\n"
    "          \"admin-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-multicast-pkts\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"description\": \"testing\",\n"
    "          \"name\": \"0/5\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": false\n"
    "        },\n"
    "        \"name\": \"0/5\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"name\": \"0/6\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-errors\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/6\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/6\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"access-vlan\": 787,\n"
    "              \"interface-mode\": \"ACCESS\"\n"
    "            }\n"
    "          },\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"0/7\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-discards\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/7\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/7\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                77,\n"
    "                787\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\"\n"
    "            }\n"
    "          },\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"name\": \"0/8\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-multicast-pkts\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/8\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/8\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"openconfig-if-ip:ipv4\": {\n"
    "                \"addresses\": {\n"
    "                  \"address\": [\n"
    "                    {\n"
    "                      \"state\": {\n"
    "                        \"ip\": \"2.3.4.5\",\n"
    "                        \"prefix-length\": 25,\n"
    "                        \"origin\": \"STATIC\"\n"
    "                      },\n"
    "                      \"config\": {\n"
    "                        \"prefix-length\": 25,\n"
    "                        \"ip\": \"2.3.4.5\"\n"
    "                      },\n"
    "                      \"ip\": \"2.3.4.5\"\n"
    "                    }\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          },\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"interface-mode\": \"TRUNK\",\n"
    "              \"trunk-vlans\": [\n"
    "                787\n"
    "              ]\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"name\": \"0/9\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-discards\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-broadcast-pkts\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/9\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/9\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          },\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                33\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\"\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"name\": \"0/10\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-multicast-pkts\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/10\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/10\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"0/11\",\n"
    "          \"admin-status\": \"DOWN\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": false,\n"
    "          \"counters\": {\n"
    "            \"out-discards\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": false\n"
    "            }\n"
    "          },\n"
    "          \"openconfig-vlan:switched-vlan\": {\n"
    "            \"config\": {\n"
    "              \"trunk-vlans\": [\n"
    "                1,\n"
    "                100\n"
    "              ],\n"
    "              \"interface-mode\": \"TRUNK\",\n"
    "              \"access-vlan\": 77\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/11\",\n"
    "          \"enabled\": false,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/11\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/12\",\n"
    "          \"counters\": {\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-octets\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/12\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/12\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"0/13\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/13\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/13\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/14\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-octets\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/14\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/14\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"name\": \"0/15\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-octets\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/15\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/15\"\n"
    "      },\n"
    "      {\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"0/16\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0\n"
    "          }\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/16\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/16\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"name\": \"0/17\",\n"
    "          \"enabled\": true,\n"
    "          \"counters\": {\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-broadcast-pkts\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-discards\": 0\n"
    "          },\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/17\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"0/17\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"name\": \"0/18\",\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\",\n"
    "          \"enabled\": true,\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"counters\": {\n"
    "            \"out-multicast-pkts\": 0,\n"
    "            \"out-broadcast-pkts\": 0,\n"
    "            \"out-discards\": 0,\n"
    "            \"out-unicast-pkts\": 0,\n"
    "            \"out-errors\": 0,\n"
    "            \"out-octets\": 0,\n"
    "            \"in-discards\": 0,\n"
    "            \"in-errors\": 0,\n"
    "            \"in-octets\": 0,\n"
    "            \"in-unicast-pkts\": 0,\n"
    "            \"in-multicast-pkts\": 0,\n"
    "            \"in-broadcast-pkts\": 0\n"
    "          }\n"
    "        },\n"
    "        \"openconfig-if-ethernet:ethernet\": {\n"
    "          \"openconfig-if-poe:poe\": {\n"
    "            \"config\": {\n"
    "              \"enabled\": true\n"
    "            }\n"
    "          }\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"0/18\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ethernetCsmacd\"\n"
    "        },\n"
    "        \"name\": \"0/18\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"3/1\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/1\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/1\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"name\": \"3/2\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true,\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/2\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/2\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"3/3\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"admin-status\": \"UP\",\n"
    "          \"oper-status\": \"DOWN\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/3\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\"\n"
    "        },\n"
    "        \"name\": \"3/3\"\n"
    "      },\n"
    "      {\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"state\": {\n"
    "          \"name\": \"3/4\",\n"
    "          \"enabled\": true,\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"admin-status\": \"UP\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/4\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/4\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"enabled\": true,\n"
    "          \"name\": \"3/5\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"admin-status\": \"UP\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/5\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/5\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"name\": \"3/6\",\n"
    "          \"enabled\": true,\n"
    "          \"oper-status\": \"DOWN\",\n"
    "          \"admin-status\": \"UP\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"name\": \"3/6\",\n"
    "          \"type\": \"iana-if-type:ieee8023adLag\",\n"
    "          \"enabled\": true\n"
    "        },\n"
    "        \"name\": \"3/6\"\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"description\": \"routedVlan\",\n"
    "          \"name\": \"4/1\",\n"
    "          \"type\": \"iana-if-type:l3ipvlan\",\n"
    "          \"enabled\": false,\n"
    "          \"oper-status\": \"UNKNOWN\",\n"
    "          \"admin-status\": \"DOWN\"\n"
    "        },\n"
    "        \"subinterfaces\": {\n"
    "          \"subinterface\": [\n"
    "            {\n"
    "              \"config\": {\n"
    "                \"index\": 0\n"
    "              },\n"
    "              \"index\": \"0\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"description\": \"routedVlan\",\n"
    "          \"name\": \"4/1\",\n"
    "          \"enabled\": false,\n"
    "          \"type\": \"iana-if-type:l3ipvlan\"\n"
    "        },\n"
    "        \"name\": \"4/1\"\n"
    "      }\n"
    "    ]\n"
    "  },\n"
    "  \"openconfig-network-instance:network-instances\": {\n"
    "    \"network-instance\": [\n"
    "      {\n"
    "        \"vlans\": {\n"
    "          \"vlan\": [\n"
    "            {\n"
    "              \"state\": {\n"
    "                \"vlan-id\": 1,\n"
    "                \"name\": \"default\",\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"config\": {\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"vlan-id\": 1\n"
    "              },\n"
    "              \"vlan-id\": \"1\"\n"
    "            },\n"
    "            {\n"
    "              \"state\": {\n"
    "                \"vlan-id\": 77,\n"
    "                \"name\": \"VLAN0077\",\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"config\": {\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"vlan-id\": 77\n"
    "              },\n"
    "              \"vlan-id\": \"77\"\n"
    "            },\n"
    "            {\n"
    "              \"state\": {\n"
    "                \"vlan-id\": 99,\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"name\": \"testing\"\n"
    "              },\n"
    "              \"config\": {\n"
    "                \"vlan-id\": 99,\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"name\": \"testing\"\n"
    "              },\n"
    "              \"vlan-id\": \"99\"\n"
    "            },\n"
    "            {\n"
    "              \"state\": {\n"
    "                \"vlan-id\": 787,\n"
    "                \"status\": \"ACTIVE\",\n"
    "                \"name\": \"another\"\n"
    "              },\n"
    "              \"config\": {\n"
    "                \"vlan-id\": 787,\n"
    "                \"name\": \"another\",\n"
    "                \"status\": \"ACTIVE\"\n"
    "              },\n"
    "              \"vlan-id\": \"787\"\n"
    "            }\n"
    "          ]\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"type\": \"openconfig-network-instance-types:DEFAULT_INSTANCE\",\n"
    "          \"name\": \"default\"\n"
    "        },\n"
    "        \"name\": \"default\"\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n"
    "";

string vlans2 =
    "{\n"
    "  \"openconfig-network-instance:vlans\": {\n"
    "    \"vlan\": [\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"vlan-id\": 1,\n"
    "          \"name\": \"default\",\n"
    "          \"status\": \"ACTIVE\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"status\": \"ACTIVE\",\n"
    "          \"vlan-id\": 1\n"
    "        },\n"
    "        \"vlan-id\": 1\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"vlan-id\": 77,\n"
    "          \"name\": \"VLAN0077\",\n"
    "          \"status\": \"ACTIVE\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"status\": \"ACTIVE\",\n"
    "          \"vlan-id\": 77\n"
    "        },\n"
    "        \"vlan-id\": 77\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"vlan-id\": 99,\n"
    "          \"status\": \"ACTIVE\",\n"
    "          \"name\": \"testing\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"vlan-id\": 99,\n"
    "          \"status\": \"ACTIVE\",\n"
    "          \"name\": \"testing\"\n"
    "        },\n"
    "        \"vlan-id\": 99\n"
    "      },\n"
    "      {\n"
    "        \"state\": {\n"
    "          \"vlan-id\": 787,\n"
    "          \"status\": \"ACTIVE\",\n"
    "          \"name\": \"another\"\n"
    "        },\n"
    "        \"config\": {\n"
    "          \"vlan-id\": 787,\n"
    "          \"name\": \"another\",\n"
    "          \"status\": \"ACTIVE\"\n"
    "        },\n"
    "        \"vlan-id\": 787\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}";
} // namespace devmand::test::utils::cli
