// Code generated by protoc-gen-go. DO NOT EDIT.
// source: feg/protos/swx_proxy.proto

package protos

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// SwxErrorCode reflects Experimental-Result values which are 3GPP failures
// to be processed by EPC. Diameter Base Protocol errors are reflected in gRPC status code
type SwxErrorCode int32

const (
	SwxErrorCode_ERROR_UNDEFINED               SwxErrorCode = 0
	SwxErrorCode_IDENTITY_ALREADY_REGISTERED   SwxErrorCode = 5005
	SwxErrorCode_USER_NO_NON_3GPP_SUBSCRIPTION SwxErrorCode = 5450
)

var SwxErrorCode_name = map[int32]string{
	0:    "ERROR_UNDEFINED",
	5005: "IDENTITY_ALREADY_REGISTERED",
	5450: "USER_NO_NON_3GPP_SUBSCRIPTION",
}

var SwxErrorCode_value = map[string]int32{
	"ERROR_UNDEFINED":               0,
	"IDENTITY_ALREADY_REGISTERED":   5005,
	"USER_NO_NON_3GPP_SUBSCRIPTION": 5450,
}

func (x SwxErrorCode) String() string {
	return proto.EnumName(SwxErrorCode_name, int32(x))
}

func (SwxErrorCode) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{0}
}

type AuthenticationScheme int32

const (
	AuthenticationScheme_EAP_AKA       AuthenticationScheme = 0
	AuthenticationScheme_EAP_AKA_PRIME AuthenticationScheme = 1
)

var AuthenticationScheme_name = map[int32]string{
	0: "EAP_AKA",
	1: "EAP_AKA_PRIME",
}

var AuthenticationScheme_value = map[string]int32{
	"EAP_AKA":       0,
	"EAP_AKA_PRIME": 1,
}

func (x AuthenticationScheme) String() string {
	return proto.EnumName(AuthenticationScheme_name, int32(x))
}

func (AuthenticationScheme) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{1}
}

// ReasonCode -> DeregistrationReason:ReasonCode
// see: https://www.etsi.org/deliver/etsi_ts/129200_129299/129229/10.05.00_60/ts_129229v100500p.pdf
type RegistrationTerminationRequest_ReasonCode int32

const (
	RegistrationTerminationRequest_PERMANENT_TERMINATION RegistrationTerminationRequest_ReasonCode = 0
	RegistrationTerminationRequest_NEW_SERVER_ASSIGNMENT RegistrationTerminationRequest_ReasonCode = 1
	RegistrationTerminationRequest_SERVER_CHANGE         RegistrationTerminationRequest_ReasonCode = 2
	RegistrationTerminationRequest_REMOVE_S_CSCF         RegistrationTerminationRequest_ReasonCode = 3
)

var RegistrationTerminationRequest_ReasonCode_name = map[int32]string{
	0: "PERMANENT_TERMINATION",
	1: "NEW_SERVER_ASSIGNMENT",
	2: "SERVER_CHANGE",
	3: "REMOVE_S_CSCF",
}

var RegistrationTerminationRequest_ReasonCode_value = map[string]int32{
	"PERMANENT_TERMINATION": 0,
	"NEW_SERVER_ASSIGNMENT": 1,
	"SERVER_CHANGE":         2,
	"REMOVE_S_CSCF":         3,
}

func (x RegistrationTerminationRequest_ReasonCode) String() string {
	return proto.EnumName(RegistrationTerminationRequest_ReasonCode_name, int32(x))
}

func (RegistrationTerminationRequest_ReasonCode) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{4, 0}
}

// AuthenticationRequest (Section 8.2.2.1)
type AuthenticationRequest struct {
	// Subscriber identifier
	UserName string `protobuf:"bytes,1,opt,name=user_name,json=userName,proto3" json:"user_name,omitempty"`
	// Number of authentication vectors requested
	SipNumAuthVectors uint32 `protobuf:"varint,2,opt,name=sip_num_auth_vectors,json=sipNumAuthVectors,proto3" json:"sip_num_auth_vectors,omitempty"`
	// EAP-AKA or EAP-AKA'
	AuthenticationScheme AuthenticationScheme `protobuf:"varint,3,opt,name=authentication_scheme,json=authenticationScheme,proto3,enum=magma.feg.AuthenticationScheme" json:"authentication_scheme,omitempty"`
	// Concatenation of RAND and AUTS in the case of resync
	ResyncInfo []byte `protobuf:"bytes,4,opt,name=resync_info,json=resyncInfo,proto3" json:"resync_info,omitempty"`
	// Send an additional SAR message to the HSS to retrieve user profile params
	RetrieveUserProfile  bool     `protobuf:"varint,5,opt,name=retrieve_user_profile,json=retrieveUserProfile,proto3" json:"retrieve_user_profile,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AuthenticationRequest) Reset()         { *m = AuthenticationRequest{} }
func (m *AuthenticationRequest) String() string { return proto.CompactTextString(m) }
func (*AuthenticationRequest) ProtoMessage()    {}
func (*AuthenticationRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{0}
}

func (m *AuthenticationRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthenticationRequest.Unmarshal(m, b)
}
func (m *AuthenticationRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthenticationRequest.Marshal(b, m, deterministic)
}
func (m *AuthenticationRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthenticationRequest.Merge(m, src)
}
func (m *AuthenticationRequest) XXX_Size() int {
	return xxx_messageInfo_AuthenticationRequest.Size(m)
}
func (m *AuthenticationRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthenticationRequest.DiscardUnknown(m)
}

var xxx_messageInfo_AuthenticationRequest proto.InternalMessageInfo

func (m *AuthenticationRequest) GetUserName() string {
	if m != nil {
		return m.UserName
	}
	return ""
}

func (m *AuthenticationRequest) GetSipNumAuthVectors() uint32 {
	if m != nil {
		return m.SipNumAuthVectors
	}
	return 0
}

func (m *AuthenticationRequest) GetAuthenticationScheme() AuthenticationScheme {
	if m != nil {
		return m.AuthenticationScheme
	}
	return AuthenticationScheme_EAP_AKA
}

func (m *AuthenticationRequest) GetResyncInfo() []byte {
	if m != nil {
		return m.ResyncInfo
	}
	return nil
}

func (m *AuthenticationRequest) GetRetrieveUserProfile() bool {
	if m != nil {
		return m.RetrieveUserProfile
	}
	return false
}

// MultimediaAuthenticationAnswer (Section 8.2.2.1)
type AuthenticationAnswer struct {
	// Subscriber identifier
	UserName string `protobuf:"bytes,1,opt,name=user_name,json=userName,proto3" json:"user_name,omitempty"`
	// For details about fields read 3GPP 29.273
	SipAuthVectors       []*AuthenticationAnswer_SIPAuthVector `protobuf:"bytes,2,rep,name=sip_auth_vectors,json=sipAuthVectors,proto3" json:"sip_auth_vectors,omitempty"`
	UserProfile          *AuthenticationAnswer_UserProfile     `protobuf:"bytes,3,opt,name=user_profile,json=userProfile,proto3" json:"user_profile,omitempty"`
	SessionId            string                                `protobuf:"bytes,4,opt,name=session_id,json=sessionId,proto3" json:"session_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                              `json:"-"`
	XXX_unrecognized     []byte                                `json:"-"`
	XXX_sizecache        int32                                 `json:"-"`
}

func (m *AuthenticationAnswer) Reset()         { *m = AuthenticationAnswer{} }
func (m *AuthenticationAnswer) String() string { return proto.CompactTextString(m) }
func (*AuthenticationAnswer) ProtoMessage()    {}
func (*AuthenticationAnswer) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{1}
}

func (m *AuthenticationAnswer) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthenticationAnswer.Unmarshal(m, b)
}
func (m *AuthenticationAnswer) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthenticationAnswer.Marshal(b, m, deterministic)
}
func (m *AuthenticationAnswer) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthenticationAnswer.Merge(m, src)
}
func (m *AuthenticationAnswer) XXX_Size() int {
	return xxx_messageInfo_AuthenticationAnswer.Size(m)
}
func (m *AuthenticationAnswer) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthenticationAnswer.DiscardUnknown(m)
}

var xxx_messageInfo_AuthenticationAnswer proto.InternalMessageInfo

func (m *AuthenticationAnswer) GetUserName() string {
	if m != nil {
		return m.UserName
	}
	return ""
}

func (m *AuthenticationAnswer) GetSipAuthVectors() []*AuthenticationAnswer_SIPAuthVector {
	if m != nil {
		return m.SipAuthVectors
	}
	return nil
}

func (m *AuthenticationAnswer) GetUserProfile() *AuthenticationAnswer_UserProfile {
	if m != nil {
		return m.UserProfile
	}
	return nil
}

func (m *AuthenticationAnswer) GetSessionId() string {
	if m != nil {
		return m.SessionId
	}
	return ""
}

// Only for EAP-AKA/EAP-AKA'
type AuthenticationAnswer_SIPAuthVector struct {
	// Contains one of EAP-AKA or EAP-AKA'
	AuthenticationScheme AuthenticationScheme `protobuf:"varint,1,opt,name=authentication_scheme,json=authenticationScheme,proto3,enum=magma.feg.AuthenticationScheme" json:"authentication_scheme,omitempty"`
	// Concatenation of challenge RAND and token AUTN
	RandAutn []byte `protobuf:"bytes,2,opt,name=rand_autn,json=randAutn,proto3" json:"rand_autn,omitempty"`
	// Expected response
	Xres []byte `protobuf:"bytes,3,opt,name=xres,proto3" json:"xres,omitempty"`
	// Confidentiality Key
	ConfidentialityKey []byte `protobuf:"bytes,4,opt,name=confidentiality_key,json=confidentialityKey,proto3" json:"confidentiality_key,omitempty"`
	// Integrity Key
	IntegrityKey         []byte   `protobuf:"bytes,5,opt,name=integrity_key,json=integrityKey,proto3" json:"integrity_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AuthenticationAnswer_SIPAuthVector) Reset()         { *m = AuthenticationAnswer_SIPAuthVector{} }
func (m *AuthenticationAnswer_SIPAuthVector) String() string { return proto.CompactTextString(m) }
func (*AuthenticationAnswer_SIPAuthVector) ProtoMessage()    {}
func (*AuthenticationAnswer_SIPAuthVector) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{1, 0}
}

func (m *AuthenticationAnswer_SIPAuthVector) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthenticationAnswer_SIPAuthVector.Unmarshal(m, b)
}
func (m *AuthenticationAnswer_SIPAuthVector) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthenticationAnswer_SIPAuthVector.Marshal(b, m, deterministic)
}
func (m *AuthenticationAnswer_SIPAuthVector) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthenticationAnswer_SIPAuthVector.Merge(m, src)
}
func (m *AuthenticationAnswer_SIPAuthVector) XXX_Size() int {
	return xxx_messageInfo_AuthenticationAnswer_SIPAuthVector.Size(m)
}
func (m *AuthenticationAnswer_SIPAuthVector) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthenticationAnswer_SIPAuthVector.DiscardUnknown(m)
}

var xxx_messageInfo_AuthenticationAnswer_SIPAuthVector proto.InternalMessageInfo

func (m *AuthenticationAnswer_SIPAuthVector) GetAuthenticationScheme() AuthenticationScheme {
	if m != nil {
		return m.AuthenticationScheme
	}
	return AuthenticationScheme_EAP_AKA
}

func (m *AuthenticationAnswer_SIPAuthVector) GetRandAutn() []byte {
	if m != nil {
		return m.RandAutn
	}
	return nil
}

func (m *AuthenticationAnswer_SIPAuthVector) GetXres() []byte {
	if m != nil {
		return m.Xres
	}
	return nil
}

func (m *AuthenticationAnswer_SIPAuthVector) GetConfidentialityKey() []byte {
	if m != nil {
		return m.ConfidentialityKey
	}
	return nil
}

func (m *AuthenticationAnswer_SIPAuthVector) GetIntegrityKey() []byte {
	if m != nil {
		return m.IntegrityKey
	}
	return nil
}

type AuthenticationAnswer_UserProfile struct {
	// MSISDN from HSS
	Msisdn               string   `protobuf:"bytes,1,opt,name=msisdn,proto3" json:"msisdn,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AuthenticationAnswer_UserProfile) Reset()         { *m = AuthenticationAnswer_UserProfile{} }
func (m *AuthenticationAnswer_UserProfile) String() string { return proto.CompactTextString(m) }
func (*AuthenticationAnswer_UserProfile) ProtoMessage()    {}
func (*AuthenticationAnswer_UserProfile) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{1, 1}
}

func (m *AuthenticationAnswer_UserProfile) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthenticationAnswer_UserProfile.Unmarshal(m, b)
}
func (m *AuthenticationAnswer_UserProfile) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthenticationAnswer_UserProfile.Marshal(b, m, deterministic)
}
func (m *AuthenticationAnswer_UserProfile) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthenticationAnswer_UserProfile.Merge(m, src)
}
func (m *AuthenticationAnswer_UserProfile) XXX_Size() int {
	return xxx_messageInfo_AuthenticationAnswer_UserProfile.Size(m)
}
func (m *AuthenticationAnswer_UserProfile) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthenticationAnswer_UserProfile.DiscardUnknown(m)
}

var xxx_messageInfo_AuthenticationAnswer_UserProfile proto.InternalMessageInfo

func (m *AuthenticationAnswer_UserProfile) GetMsisdn() string {
	if m != nil {
		return m.Msisdn
	}
	return ""
}

// RegistrationRequest:
// ServerAssignmentRequest with ServerAssignmentType set to (DE)/REGISTRATION (Section 8.2.2.3)
type RegistrationRequest struct {
	// Subscriber identifier
	UserName             string   `protobuf:"bytes,1,opt,name=user_name,json=userName,proto3" json:"user_name,omitempty"`
	SessionId            string   `protobuf:"bytes,2,opt,name=session_id,json=sessionId,proto3" json:"session_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RegistrationRequest) Reset()         { *m = RegistrationRequest{} }
func (m *RegistrationRequest) String() string { return proto.CompactTextString(m) }
func (*RegistrationRequest) ProtoMessage()    {}
func (*RegistrationRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{2}
}

func (m *RegistrationRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RegistrationRequest.Unmarshal(m, b)
}
func (m *RegistrationRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RegistrationRequest.Marshal(b, m, deterministic)
}
func (m *RegistrationRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RegistrationRequest.Merge(m, src)
}
func (m *RegistrationRequest) XXX_Size() int {
	return xxx_messageInfo_RegistrationRequest.Size(m)
}
func (m *RegistrationRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_RegistrationRequest.DiscardUnknown(m)
}

var xxx_messageInfo_RegistrationRequest proto.InternalMessageInfo

func (m *RegistrationRequest) GetUserName() string {
	if m != nil {
		return m.UserName
	}
	return ""
}

func (m *RegistrationRequest) GetSessionId() string {
	if m != nil {
		return m.SessionId
	}
	return ""
}

// RegistrationAnswer:
// ServerAssignmentAnswer with ServerAssignmentType set to (DE)/REGISTRATION (Section 8.2.2.3)
type RegistrationAnswer struct {
	SessionId            string   `protobuf:"bytes,1,opt,name=session_id,json=sessionId,proto3" json:"session_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RegistrationAnswer) Reset()         { *m = RegistrationAnswer{} }
func (m *RegistrationAnswer) String() string { return proto.CompactTextString(m) }
func (*RegistrationAnswer) ProtoMessage()    {}
func (*RegistrationAnswer) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{3}
}

func (m *RegistrationAnswer) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RegistrationAnswer.Unmarshal(m, b)
}
func (m *RegistrationAnswer) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RegistrationAnswer.Marshal(b, m, deterministic)
}
func (m *RegistrationAnswer) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RegistrationAnswer.Merge(m, src)
}
func (m *RegistrationAnswer) XXX_Size() int {
	return xxx_messageInfo_RegistrationAnswer.Size(m)
}
func (m *RegistrationAnswer) XXX_DiscardUnknown() {
	xxx_messageInfo_RegistrationAnswer.DiscardUnknown(m)
}

var xxx_messageInfo_RegistrationAnswer proto.InternalMessageInfo

func (m *RegistrationAnswer) GetSessionId() string {
	if m != nil {
		return m.SessionId
	}
	return ""
}

// RegistrationTerminationRequest, see: http://www.qtc.jp/3GPP/Specs/29273-920.pdf Section 8.2.2.4
type RegistrationTerminationRequest struct {
	// Subscriber identifier
	UserName             string                                    `protobuf:"bytes,1,opt,name=user_name,json=userName,proto3" json:"user_name,omitempty"`
	ReasonCode           RegistrationTerminationRequest_ReasonCode `protobuf:"varint,2,opt,name=reason_code,json=reasonCode,proto3,enum=magma.feg.RegistrationTerminationRequest_ReasonCode" json:"reason_code,omitempty"`
	ReasonInfo           string                                    `protobuf:"bytes,3,opt,name=reason_info,json=reasonInfo,proto3" json:"reason_info,omitempty"`
	SessionId            string                                    `protobuf:"bytes,4,opt,name=session_id,json=sessionId,proto3" json:"session_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                                  `json:"-"`
	XXX_unrecognized     []byte                                    `json:"-"`
	XXX_sizecache        int32                                     `json:"-"`
}

func (m *RegistrationTerminationRequest) Reset()         { *m = RegistrationTerminationRequest{} }
func (m *RegistrationTerminationRequest) String() string { return proto.CompactTextString(m) }
func (*RegistrationTerminationRequest) ProtoMessage()    {}
func (*RegistrationTerminationRequest) Descriptor() ([]byte, []int) {
	return fileDescriptor_56882954a8fab9d2, []int{4}
}

func (m *RegistrationTerminationRequest) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RegistrationTerminationRequest.Unmarshal(m, b)
}
func (m *RegistrationTerminationRequest) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RegistrationTerminationRequest.Marshal(b, m, deterministic)
}
func (m *RegistrationTerminationRequest) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RegistrationTerminationRequest.Merge(m, src)
}
func (m *RegistrationTerminationRequest) XXX_Size() int {
	return xxx_messageInfo_RegistrationTerminationRequest.Size(m)
}
func (m *RegistrationTerminationRequest) XXX_DiscardUnknown() {
	xxx_messageInfo_RegistrationTerminationRequest.DiscardUnknown(m)
}

var xxx_messageInfo_RegistrationTerminationRequest proto.InternalMessageInfo

func (m *RegistrationTerminationRequest) GetUserName() string {
	if m != nil {
		return m.UserName
	}
	return ""
}

func (m *RegistrationTerminationRequest) GetReasonCode() RegistrationTerminationRequest_ReasonCode {
	if m != nil {
		return m.ReasonCode
	}
	return RegistrationTerminationRequest_PERMANENT_TERMINATION
}

func (m *RegistrationTerminationRequest) GetReasonInfo() string {
	if m != nil {
		return m.ReasonInfo
	}
	return ""
}

func (m *RegistrationTerminationRequest) GetSessionId() string {
	if m != nil {
		return m.SessionId
	}
	return ""
}

func init() {
	proto.RegisterEnum("magma.feg.SwxErrorCode", SwxErrorCode_name, SwxErrorCode_value)
	proto.RegisterEnum("magma.feg.AuthenticationScheme", AuthenticationScheme_name, AuthenticationScheme_value)
	proto.RegisterEnum("magma.feg.RegistrationTerminationRequest_ReasonCode", RegistrationTerminationRequest_ReasonCode_name, RegistrationTerminationRequest_ReasonCode_value)
	proto.RegisterType((*AuthenticationRequest)(nil), "magma.feg.AuthenticationRequest")
	proto.RegisterType((*AuthenticationAnswer)(nil), "magma.feg.AuthenticationAnswer")
	proto.RegisterType((*AuthenticationAnswer_SIPAuthVector)(nil), "magma.feg.AuthenticationAnswer.SIPAuthVector")
	proto.RegisterType((*AuthenticationAnswer_UserProfile)(nil), "magma.feg.AuthenticationAnswer.UserProfile")
	proto.RegisterType((*RegistrationRequest)(nil), "magma.feg.RegistrationRequest")
	proto.RegisterType((*RegistrationAnswer)(nil), "magma.feg.RegistrationAnswer")
	proto.RegisterType((*RegistrationTerminationRequest)(nil), "magma.feg.RegistrationTerminationRequest")
}

func init() { proto.RegisterFile("feg/protos/swx_proxy.proto", fileDescriptor_56882954a8fab9d2) }

var fileDescriptor_56882954a8fab9d2 = []byte{
	// 830 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x55, 0xdd, 0x6e, 0xe2, 0x46,
	0x14, 0x8e, 0x49, 0x76, 0x0b, 0x07, 0x92, 0x92, 0x49, 0xa8, 0xd8, 0x44, 0xd9, 0x20, 0xaa, 0xaa,
	0x34, 0x55, 0x41, 0x22, 0x55, 0xef, 0xbd, 0x30, 0x4b, 0xad, 0x14, 0x43, 0xc7, 0x26, 0xab, 0xf4,
	0x66, 0xe4, 0x9a, 0x03, 0xb1, 0x1a, 0xdb, 0x74, 0xc6, 0x0e, 0xf0, 0x10, 0x95, 0xda, 0x17, 0xea,
	0x03, 0xf4, 0x59, 0xfa, 0x06, 0xbd, 0xa9, 0x3c, 0x98, 0x04, 0x50, 0x49, 0x22, 0x75, 0xaf, 0xec,
	0x39, 0x3f, 0xdf, 0x9c, 0xf9, 0xbe, 0x73, 0x66, 0xe0, 0x64, 0x84, 0xe3, 0xc6, 0x44, 0x84, 0x51,
	0x28, 0x1b, 0x72, 0x3a, 0xe3, 0x13, 0x11, 0xce, 0xe6, 0x75, 0x65, 0x20, 0x39, 0xdf, 0x19, 0xfb,
	0x4e, 0x7d, 0x84, 0xe3, 0xea, 0xef, 0x19, 0x28, 0xe9, 0x71, 0x74, 0x8b, 0x41, 0xe4, 0xb9, 0x4e,
	0xe4, 0x85, 0x01, 0xc3, 0x5f, 0x63, 0x94, 0x11, 0x39, 0x85, 0x5c, 0x2c, 0x51, 0xf0, 0xc0, 0xf1,
	0xb1, 0xac, 0x55, 0xb4, 0x5a, 0x8e, 0x65, 0x13, 0x83, 0xe9, 0xf8, 0x48, 0x1a, 0x70, 0x2c, 0xbd,
	0x09, 0x0f, 0x62, 0x9f, 0x3b, 0x71, 0x74, 0xcb, 0xef, 0xd1, 0x8d, 0x42, 0x21, 0xcb, 0x99, 0x8a,
	0x56, 0xdb, 0x67, 0x87, 0xd2, 0x9b, 0x98, 0xb1, 0x9f, 0xe0, 0x5e, 0x2f, 0x1c, 0xc4, 0x86, 0x92,
	0xb3, 0xb6, 0x0d, 0x97, 0xee, 0x2d, 0xfa, 0x58, 0xde, 0xad, 0x68, 0xb5, 0x83, 0xe6, 0x79, 0xfd,
	0xa1, 0xa4, 0xfa, 0x7a, 0x39, 0x96, 0x0a, 0x63, 0xc7, 0xce, 0x7f, 0x58, 0xc9, 0x39, 0xe4, 0x05,
	0xca, 0x79, 0xe0, 0x72, 0x2f, 0x18, 0x85, 0xe5, 0xbd, 0x8a, 0x56, 0x2b, 0x30, 0x58, 0x98, 0x8c,
	0x60, 0x14, 0x92, 0x26, 0x94, 0x04, 0x46, 0xc2, 0xc3, 0x7b, 0xe4, 0xea, 0x34, 0x13, 0x11, 0x8e,
	0xbc, 0x3b, 0x2c, 0xbf, 0xaa, 0x68, 0xb5, 0x2c, 0x3b, 0x5a, 0x3a, 0x07, 0x12, 0x45, 0x7f, 0xe1,
	0xaa, 0xfe, 0xb1, 0x07, 0xc7, 0xeb, 0x35, 0xe8, 0x81, 0x9c, 0xa2, 0x78, 0x9a, 0x91, 0x0f, 0x50,
	0x4c, 0x18, 0xd9, 0x60, 0x63, 0xb7, 0x96, 0x6f, 0x7e, 0xb3, 0xf5, 0x6c, 0x0b, 0xdc, 0xba, 0x65,
	0xf4, 0x1f, 0xa9, 0x62, 0x07, 0xd2, 0x9b, 0xac, 0x32, 0x67, 0x42, 0x61, 0xad, 0xf2, 0x84, 0xb0,
	0x7c, 0xf3, 0xeb, 0xe7, 0x40, 0x57, 0x4e, 0xc4, 0xf2, 0xf1, 0xe3, 0x82, 0x9c, 0x01, 0x48, 0x94,
	0x32, 0x91, 0xc0, 0x1b, 0x2a, 0xca, 0x72, 0x2c, 0x97, 0x5a, 0x8c, 0xe1, 0xc9, 0xdf, 0x1a, 0xec,
	0xaf, 0x15, 0xb4, 0x5d, 0x3a, 0xed, 0xff, 0x48, 0x77, 0x0a, 0x39, 0xe1, 0x04, 0xc3, 0x84, 0xb0,
	0x40, 0xb5, 0x4d, 0x81, 0x65, 0x13, 0x83, 0x1e, 0x47, 0x01, 0x21, 0xb0, 0x37, 0x13, 0x28, 0xd5,
	0x59, 0x0b, 0x4c, 0xfd, 0x93, 0x06, 0x1c, 0xb9, 0x61, 0x30, 0xf2, 0x86, 0x09, 0x94, 0x73, 0xe7,
	0x45, 0x73, 0xfe, 0x0b, 0xce, 0x53, 0xcd, 0xc9, 0x86, 0xeb, 0x0a, 0xe7, 0xe4, 0x73, 0xd8, 0xf7,
	0x82, 0x08, 0xc7, 0x62, 0x19, 0xfa, 0x4a, 0x85, 0x16, 0x1e, 0x8c, 0x57, 0x38, 0x3f, 0xf9, 0x02,
	0xf2, 0x2b, 0x4c, 0x91, 0xcf, 0xe0, 0xb5, 0x2f, 0x3d, 0x39, 0x0c, 0x52, 0x7d, 0xd3, 0x55, 0xf5,
	0x47, 0x38, 0x62, 0x38, 0xf6, 0x64, 0x24, 0x5e, 0x3e, 0x23, 0xeb, 0x44, 0x67, 0x36, 0x88, 0xae,
	0x5e, 0x02, 0x59, 0x85, 0x4c, 0x7b, 0x6c, 0x3d, 0x49, 0xdb, 0x4c, 0xfa, 0x33, 0x03, 0x6f, 0x57,
	0xb3, 0x6c, 0x14, 0xbe, 0x17, 0xbc, 0xbc, 0xa6, 0x41, 0x32, 0x30, 0x8e, 0x0c, 0x03, 0xee, 0x86,
	0x43, 0x54, 0x45, 0x1d, 0x34, 0xbf, 0x5d, 0x51, 0xf0, 0x69, 0xf0, 0x3a, 0x53, 0xc9, 0xad, 0x70,
	0x88, 0xc9, 0x98, 0x2d, 0xff, 0x17, 0x73, 0xa8, 0x60, 0xd5, 0x1c, 0xee, 0xaa, 0x5d, 0xd3, 0x00,
	0x35, 0x87, 0x4f, 0x37, 0x5d, 0xf5, 0x16, 0xe0, 0x11, 0x99, 0xbc, 0x81, 0x52, 0x9f, 0xb2, 0xae,
	0x6e, 0x52, 0xd3, 0xe6, 0x36, 0x65, 0x5d, 0xc3, 0xd4, 0x6d, 0xa3, 0x67, 0x16, 0x77, 0x12, 0x97,
	0x49, 0x3f, 0x70, 0x8b, 0xb2, 0x6b, 0xca, 0xb8, 0x6e, 0x59, 0x46, 0xc7, 0xec, 0x52, 0xd3, 0x2e,
	0x6a, 0xe4, 0x10, 0xf6, 0x53, 0x73, 0xeb, 0x7b, 0xdd, 0xec, 0xd0, 0x62, 0x26, 0x31, 0x31, 0xda,
	0xed, 0x5d, 0x53, 0x6e, 0xf1, 0x96, 0xd5, 0x7a, 0x5f, 0xdc, 0xbd, 0xf0, 0xa0, 0x60, 0x4d, 0x67,
	0x54, 0x88, 0x50, 0xa8, 0xbd, 0x8e, 0xe0, 0x53, 0xca, 0x58, 0x8f, 0xf1, 0x81, 0xd9, 0xa6, 0xef,
	0x0d, 0x93, 0xb6, 0x8b, 0x3b, 0xa4, 0x02, 0xa7, 0x46, 0x9b, 0x9a, 0xb6, 0x61, 0xdf, 0x70, 0xfd,
	0x07, 0x46, 0xf5, 0xf6, 0x0d, 0x67, 0xb4, 0x63, 0x58, 0x36, 0x65, 0xb4, 0x5d, 0xfc, 0xed, 0x4b,
	0x52, 0x85, 0xb3, 0x81, 0x45, 0x19, 0x37, 0x7b, 0xdc, 0xec, 0x99, 0xfc, 0xb2, 0xd3, 0xef, 0x73,
	0x6b, 0xf0, 0xce, 0x6a, 0x31, 0xa3, 0xaf, 0x4a, 0xfd, 0xeb, 0xe2, 0xe2, 0xbb, 0xcd, 0x6b, 0x24,
	0xed, 0xfc, 0x3c, 0x7c, 0x42, 0xf5, 0x3e, 0xd7, 0xaf, 0xf4, 0xe2, 0x4e, 0x52, 0x62, 0xba, 0xe0,
	0x7d, 0x66, 0x74, 0x69, 0x51, 0x6b, 0xfe, 0xa3, 0x41, 0xd6, 0x9a, 0xce, 0xfa, 0xc9, 0x85, 0x4d,
	0x2c, 0x28, 0xac, 0x80, 0x20, 0xa9, 0x6c, 0x9d, 0xb6, 0x54, 0xa2, 0x93, 0xf3, 0x67, 0x6e, 0x86,
	0xea, 0x0e, 0xb9, 0x82, 0xec, 0x42, 0x67, 0x14, 0xe4, 0xed, 0x16, 0xf1, 0x97, 0x70, 0x67, 0x5b,
	0xfc, 0x0f, 0x60, 0x5d, 0x80, 0x36, 0x8a, 0x8f, 0x05, 0xd7, 0x9c, 0xc1, 0xa1, 0x35, 0x9d, 0x75,
	0x9c, 0x08, 0xa7, 0xce, 0xdc, 0x42, 0x71, 0xef, 0xb9, 0x48, 0x5c, 0x28, 0x2d, 0x9b, 0x11, 0x57,
	0xb3, 0xc8, 0x57, 0x2f, 0x6e, 0xdd, 0x67, 0x77, 0x7e, 0x77, 0xfa, 0xd3, 0x1b, 0x15, 0xd1, 0x48,
	0x5e, 0x4e, 0xf7, 0x2e, 0x8c, 0x87, 0x8d, 0x71, 0x98, 0x3e, 0xa1, 0x3f, 0xbf, 0x56, 0xdf, 0xcb,
	0x7f, 0x03, 0x00, 0x00, 0xff, 0xff, 0xe6, 0xac, 0xc4, 0x55, 0x57, 0x07, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConnInterface

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion6

// SwxProxyClient is the client API for SwxProxy service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type SwxProxyClient interface {
	// Retrieve authentication vectors from the HSS using MAR/MAA
	Authenticate(ctx context.Context, in *AuthenticationRequest, opts ...grpc.CallOption) (*AuthenticationAnswer, error)
	// Register the AAA server serving a user to the HSS using SAR/SAA
	Register(ctx context.Context, in *RegistrationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error)
	// Deregister the AAA server serving a user to the HSS using SAR/SAA
	Deregister(ctx context.Context, in *RegistrationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error)
}

type swxProxyClient struct {
	cc grpc.ClientConnInterface
}

func NewSwxProxyClient(cc grpc.ClientConnInterface) SwxProxyClient {
	return &swxProxyClient{cc}
}

func (c *swxProxyClient) Authenticate(ctx context.Context, in *AuthenticationRequest, opts ...grpc.CallOption) (*AuthenticationAnswer, error) {
	out := new(AuthenticationAnswer)
	err := c.cc.Invoke(ctx, "/magma.feg.SwxProxy/Authenticate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *swxProxyClient) Register(ctx context.Context, in *RegistrationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error) {
	out := new(RegistrationAnswer)
	err := c.cc.Invoke(ctx, "/magma.feg.SwxProxy/Register", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *swxProxyClient) Deregister(ctx context.Context, in *RegistrationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error) {
	out := new(RegistrationAnswer)
	err := c.cc.Invoke(ctx, "/magma.feg.SwxProxy/Deregister", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SwxProxyServer is the server API for SwxProxy service.
type SwxProxyServer interface {
	// Retrieve authentication vectors from the HSS using MAR/MAA
	Authenticate(context.Context, *AuthenticationRequest) (*AuthenticationAnswer, error)
	// Register the AAA server serving a user to the HSS using SAR/SAA
	Register(context.Context, *RegistrationRequest) (*RegistrationAnswer, error)
	// Deregister the AAA server serving a user to the HSS using SAR/SAA
	Deregister(context.Context, *RegistrationRequest) (*RegistrationAnswer, error)
}

// UnimplementedSwxProxyServer can be embedded to have forward compatible implementations.
type UnimplementedSwxProxyServer struct {
}

func (*UnimplementedSwxProxyServer) Authenticate(ctx context.Context, req *AuthenticationRequest) (*AuthenticationAnswer, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Authenticate not implemented")
}
func (*UnimplementedSwxProxyServer) Register(ctx context.Context, req *RegistrationRequest) (*RegistrationAnswer, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Register not implemented")
}
func (*UnimplementedSwxProxyServer) Deregister(ctx context.Context, req *RegistrationRequest) (*RegistrationAnswer, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Deregister not implemented")
}

func RegisterSwxProxyServer(s *grpc.Server, srv SwxProxyServer) {
	s.RegisterService(&_SwxProxy_serviceDesc, srv)
}

func _SwxProxy_Authenticate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AuthenticationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SwxProxyServer).Authenticate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/magma.feg.SwxProxy/Authenticate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SwxProxyServer).Authenticate(ctx, req.(*AuthenticationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SwxProxy_Register_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RegistrationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SwxProxyServer).Register(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/magma.feg.SwxProxy/Register",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SwxProxyServer).Register(ctx, req.(*RegistrationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SwxProxy_Deregister_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RegistrationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SwxProxyServer).Deregister(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/magma.feg.SwxProxy/Deregister",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SwxProxyServer).Deregister(ctx, req.(*RegistrationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _SwxProxy_serviceDesc = grpc.ServiceDesc{
	ServiceName: "magma.feg.SwxProxy",
	HandlerType: (*SwxProxyServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Authenticate",
			Handler:    _SwxProxy_Authenticate_Handler,
		},
		{
			MethodName: "Register",
			Handler:    _SwxProxy_Register_Handler,
		},
		{
			MethodName: "Deregister",
			Handler:    _SwxProxy_Deregister_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "feg/protos/swx_proxy.proto",
}

// SwxGatewayServiceClient is the client API for SwxGatewayService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type SwxGatewayServiceClient interface {
	// TerminateRegistration - handler of SWx Registration-Termination,
	// see: http://www.qtc.jp/3GPP/Specs/29273-920.pdf Section 8.2.2.4
	TerminateRegistration(ctx context.Context, in *RegistrationTerminationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error)
}

type swxGatewayServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewSwxGatewayServiceClient(cc grpc.ClientConnInterface) SwxGatewayServiceClient {
	return &swxGatewayServiceClient{cc}
}

func (c *swxGatewayServiceClient) TerminateRegistration(ctx context.Context, in *RegistrationTerminationRequest, opts ...grpc.CallOption) (*RegistrationAnswer, error) {
	out := new(RegistrationAnswer)
	err := c.cc.Invoke(ctx, "/magma.feg.SwxGatewayService/TerminateRegistration", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SwxGatewayServiceServer is the server API for SwxGatewayService service.
type SwxGatewayServiceServer interface {
	// TerminateRegistration - handler of SWx Registration-Termination,
	// see: http://www.qtc.jp/3GPP/Specs/29273-920.pdf Section 8.2.2.4
	TerminateRegistration(context.Context, *RegistrationTerminationRequest) (*RegistrationAnswer, error)
}

// UnimplementedSwxGatewayServiceServer can be embedded to have forward compatible implementations.
type UnimplementedSwxGatewayServiceServer struct {
}

func (*UnimplementedSwxGatewayServiceServer) TerminateRegistration(ctx context.Context, req *RegistrationTerminationRequest) (*RegistrationAnswer, error) {
	return nil, status.Errorf(codes.Unimplemented, "method TerminateRegistration not implemented")
}

func RegisterSwxGatewayServiceServer(s *grpc.Server, srv SwxGatewayServiceServer) {
	s.RegisterService(&_SwxGatewayService_serviceDesc, srv)
}

func _SwxGatewayService_TerminateRegistration_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RegistrationTerminationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SwxGatewayServiceServer).TerminateRegistration(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/magma.feg.SwxGatewayService/TerminateRegistration",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SwxGatewayServiceServer).TerminateRegistration(ctx, req.(*RegistrationTerminationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _SwxGatewayService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "magma.feg.SwxGatewayService",
	HandlerType: (*SwxGatewayServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "TerminateRegistration",
			Handler:    _SwxGatewayService_TerminateRegistration_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "feg/protos/swx_proxy.proto",
}
