/*
 * Copyright (c) Facebook, Inc. and its affiliates.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

// Code generated by go-swagger; DO NOT EDIT.

package types

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// GatewayEpcConfigs EPC (evolved packet core) configuration for a gateway
// swagger:model gateway_epc_configs
type GatewayEpcConfigs struct {

	// ip block
	// Required: true
	// Max Length: 49
	// Min Length: 5
	IPBlock string `json:"ip_block" magma_alt_name:"IpBlock"`

	// nat enabled
	NatEnabled bool `json:"nat_enabled,omitempty"`
}

// Validate validates this gateway epc configs
func (m *GatewayEpcConfigs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIPBlock(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *GatewayEpcConfigs) validateIPBlock(formats strfmt.Registry) error {

	if err := validate.RequiredString("ip_block", "body", string(m.IPBlock)); err != nil {
		return err
	}

	if err := validate.MinLength("ip_block", "body", string(m.IPBlock), 5); err != nil {
		return err
	}

	if err := validate.MaxLength("ip_block", "body", string(m.IPBlock), 49); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *GatewayEpcConfigs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *GatewayEpcConfigs) UnmarshalBinary(b []byte) error {
	var res GatewayEpcConfigs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
