/*
 * Copyright (c) Facebook, Inc. and its affiliates.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

// Code generated by go-swagger; DO NOT EDIT.

package types

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// GatewayNonEpsServiceConfigs Non-EPS service configuration for a gateway
// swagger:model gateway_non_eps_service_configs
type GatewayNonEpsServiceConfigs struct {

	// arfcn 2g
	Arfcn2g []uint32 `json:"arfcn_2g" magma_alt_name:"Arfcn_2G"`

	// csfb mcc
	// Pattern: ^(\d{3})$
	CsfbMcc string `json:"csfb_mcc,omitempty"`

	// csfb mnc
	// Pattern: ^(\d{2,3})$
	CsfbMnc string `json:"csfb_mnc,omitempty"`

	// csfb rat
	// Enum: [0 1]
	CsfbRat uint32 `json:"csfb_rat,omitempty"`

	// lac
	Lac uint32 `json:"lac,omitempty"`

	// non eps service control
	// Enum: [0 1 2]
	NonEpsServiceControl uint32 `json:"non_eps_service_control,omitempty"`
}

// Validate validates this gateway non eps service configs
func (m *GatewayNonEpsServiceConfigs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCsfbMcc(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCsfbMnc(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCsfbRat(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNonEpsServiceControl(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *GatewayNonEpsServiceConfigs) validateCsfbMcc(formats strfmt.Registry) error {

	if swag.IsZero(m.CsfbMcc) { // not required
		return nil
	}

	if err := validate.Pattern("csfb_mcc", "body", string(m.CsfbMcc), `^(\d{3})$`); err != nil {
		return err
	}

	return nil
}

func (m *GatewayNonEpsServiceConfigs) validateCsfbMnc(formats strfmt.Registry) error {

	if swag.IsZero(m.CsfbMnc) { // not required
		return nil
	}

	if err := validate.Pattern("csfb_mnc", "body", string(m.CsfbMnc), `^(\d{2,3})$`); err != nil {
		return err
	}

	return nil
}

var gatewayNonEpsServiceConfigsTypeCsfbRatPropEnum []interface{}

func init() {
	var res []uint32
	if err := json.Unmarshal([]byte(`[0,1]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		gatewayNonEpsServiceConfigsTypeCsfbRatPropEnum = append(gatewayNonEpsServiceConfigsTypeCsfbRatPropEnum, v)
	}
}

// prop value enum
func (m *GatewayNonEpsServiceConfigs) validateCsfbRatEnum(path, location string, value uint32) error {
	if err := validate.Enum(path, location, value, gatewayNonEpsServiceConfigsTypeCsfbRatPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *GatewayNonEpsServiceConfigs) validateCsfbRat(formats strfmt.Registry) error {

	if swag.IsZero(m.CsfbRat) { // not required
		return nil
	}

	// value enum
	if err := m.validateCsfbRatEnum("csfb_rat", "body", m.CsfbRat); err != nil {
		return err
	}

	return nil
}

var gatewayNonEpsServiceConfigsTypeNonEpsServiceControlPropEnum []interface{}

func init() {
	var res []uint32
	if err := json.Unmarshal([]byte(`[0,1,2]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		gatewayNonEpsServiceConfigsTypeNonEpsServiceControlPropEnum = append(gatewayNonEpsServiceConfigsTypeNonEpsServiceControlPropEnum, v)
	}
}

// prop value enum
func (m *GatewayNonEpsServiceConfigs) validateNonEpsServiceControlEnum(path, location string, value uint32) error {
	if err := validate.Enum(path, location, value, gatewayNonEpsServiceConfigsTypeNonEpsServiceControlPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *GatewayNonEpsServiceConfigs) validateNonEpsServiceControl(formats strfmt.Registry) error {

	if swag.IsZero(m.NonEpsServiceControl) { // not required
		return nil
	}

	// value enum
	if err := m.validateNonEpsServiceControlEnum("non_eps_service_control", "body", m.NonEpsServiceControl); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *GatewayNonEpsServiceConfigs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *GatewayNonEpsServiceConfigs) UnmarshalBinary(b []byte) error {
	var res GatewayNonEpsServiceConfigs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
