#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass
from datetime import datetime
from gql.gql.datetime_utils import DATETIME_FIELD
from gql.gql.graphql_client import GraphqlClient
from gql.gql.client import OperationException
from gql.gql.reporter import FailedOperationException
from functools import partial
from numbers import Number
from typing import Any, Callable, List, Mapping, Optional
from time import perf_counter
from dataclasses_json import DataClassJsonMixin

from ..fragment.location import LocationFragment, QUERY as LocationFragmentQuery
from ..input.location_filter import LocationFilterInput


QUERY: List[str] = LocationFragmentQuery + ["""
query LocationSearchQuery($filters: [LocationFilterInput!]!, $limit: Int) {
  locationSearch(filters: $filters, limit: $limit) {
    locations {
      ...LocationFragment
    }
    count
  }
}

"""]

@dataclass
class LocationSearchQuery(DataClassJsonMixin):
    @dataclass
    class LocationSearchQueryData(DataClassJsonMixin):
        @dataclass
        class LocationSearchResult(DataClassJsonMixin):
            @dataclass
            class Location(LocationFragment):
                pass

            locations: List[Location]
            count: int

        locationSearch: LocationSearchResult

    data: LocationSearchQueryData

    @classmethod
    # fmt: off
    def execute(cls, client: GraphqlClient, filters: List[LocationFilterInput] = [], limit: Optional[int] = None) -> LocationSearchQueryData.LocationSearchResult:
        # fmt: off
        variables = {"filters": filters, "limit": limit}
        try:
            network_start = perf_counter()
            response_text = client.call(''.join(set(QUERY)), variables=variables)
            decode_start = perf_counter()
            res = cls.from_json(response_text).data
            decode_time = perf_counter() - decode_start
            network_time = decode_start - network_start
            client.reporter.log_successful_operation("LocationSearchQuery", variables, network_time, decode_time)
            return res.locationSearch
        except OperationException as e:
            raise FailedOperationException(
                client.reporter,
                e.err_msg,
                e.err_id,
                "LocationSearchQuery",
                variables,
            )
