#!/usr/bin/env python3
# Copyright (c) 2004-present Facebook All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

import os

import pkg_resources
from grpc_tools import protoc


OUTPUT_PATH = "pyinventory_tests/grpc"
PROTO_PATH = "../../graph/graphgrpc"
proto_include = pkg_resources.resource_filename("grpc_tools", "_proto")

protoc.main(
    (
        "",
        f"-I{PROTO_PATH}",
        f"--python_out={OUTPUT_PATH}",
        f"--grpc_python_out={OUTPUT_PATH}",
        f"{PROTO_PATH}/rpc.proto",
        f"-I{proto_include}",
    )
)

for filename in ("rpc_pb2.py", "rpc_pb2_grpc.py"):
    filepath = os.path.join(OUTPUT_PATH, filename)
    with open(filepath, "r+") as f:
        content = f.read()
        f.seek(0, 0)
        f.write("#!/usr/bin/env python3\n")
        f.write("# pyre-ignore-all-errors\n")
        f.write("# @" + "generated AUTOGENERATED file. Do not Change!\n")
        f.write("\n")
        f.write(content)
